/*-------------------------------------------------------------------------
 *
 * multi_logical_replication.h
 *
 *    Declarations for public functions and variables used in logical replication
 *    on the distributed tables while moving shards.
 *
 * Copyright (c) 2017, Citus Data, Inc.
 *
 *-------------------------------------------------------------------------
 */
#ifndef MULTI_LOGICAL_REPLICATION_H_
#define MULTI_LOGICAL_REPLICATION_H_


#include "nodes/pg_list.h"


/* Config variables managed via guc.c */
extern int LogicalReplicationTimeout;
extern bool RunningUnderIsolationTest;

extern bool PlacementMovedUsingLogicalReplicationInTX;


extern void LogicallyReplicateShards(List *shardList, char *sourceNodeName,
									 int sourceNodePort, char *targetNodeName,
									 int targetNodePort);

/* exported for regression tests */
extern List * GetForeignConstraintCommandsToReferenceTable(ShardInterval *shardInterval);


#endif /* MULTI_LOGICAL_REPLICATION_H_ */
